unit Geservr;

Interface

{MODIFIED FROM TRNKTOON.ZIP (ADH)}

uses
  SysUtils,WinTypes,
  Alchemw, Caexcomm;

type String42 = String[42];

type CADataStruct = Record
        fFileSent:        BOOL;
     end;

procedure PlugActivate(SlotH: LPSLOT; activate: BOOL); export;
procedure PlugPaint(SlotH: LPSLOT; dc: HDC; erase: BOOL; var rect: TRECT); export;
procedure PlugResize(SlotH: LPSLOT; width, height: WORD); export;
function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD; export;
function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL; export;
function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL; export;
procedure PlugDestroy(SlotH: LPSLOT); export;
function  PlugButton(SlotH: LPSLOT; id: WORD):WORD; export;
function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL; export;
function  PlugType(SlotH: LPSLOT; title: PChar):WORD; export;
function  PlugProcess(SlotH: LPSLOT):WORD; export;
function  PlugDLLSize(SlotH: LPSLOT):LongInt; export;
function  PlugNextDLL(SlotH: LPSLOT; name: PChar; limit: WORD; dest: PChar;
          dlim: WORD):BOOL; export;
function  PlugDLLVerify(SlotH: LPSLOT; curOS: LongInt; info: Pointer;
          company, intern, ver, descript: PChar ):WORD; export;
function  PlugCommand(SlotH: LPSLOT; cCMD: Pointer; cLen: WORD):WORD; export;

procedure GetData(var TheSlot: LPVOID; var TheData: TPlugInfo); {adh}

implementation

procedure PlugActivate(SlotH: LPSLOT; activate: BOOL);
begin
end;

procedure PlugPaint(SlotH: LPSLOT; dc: HDC; erase: BOOL; var rect: TRECT);
begin
end;

procedure PlugResize(SlotH: LPSLOT; width, height: WORD);
begin
end;

function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD;
begin
     Result := AL_OK;
end;

function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL;
begin
     Result := TRUE;
end;

function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL;
begin
     Result := FALSE;
end;

procedure PlugDestroy(SlotH: LPSLOT);

begin

end;

function  PlugButton(SlotH: LPSLOT; id: WORD):WORD;
begin
     Result := AL_IDLE;
end;

function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL;
begin
     Result := BOOL(AL_IDLE);
end;

function  PlugType(SlotH: LPSLOT; title: PChar):WORD;
var ds: ^CADataStruct;

begin

     AlAlloc(SlotH, sizeof(CADataStruct));   {Allocate a memory block
                                              of the size you wan't to
                                              store transfer data in
                                              memory}  {adh}

      ds := AlLock(SlotH);                   {Retrive the Block and
                                             lock it so we can access
                                             it without interuption from
                                             windows} {adh}

      ds^.fFileSent := FALSE;          {adh}{Tell the client plug that
                                             no dll has been sent.}

     AlUnlock(SlotH);                       {Release the memory back to
                                             windows to be moved around
                                             as it see's fit} {adh}
     StrPCopy( title, 'GENCLINT.DLL'); {Title that will show in host}{adh}

     Result := AL_WIN_PLUGIN; {Add AL_WIN_MULTI AND PUT IN SHELLS FOR
                                PLUGBROADCAST IF YOU WAN'T TO RETRIVE
                                INFORMATION ABOUT THE OTHER USERS IN
                                THE PLUG. THERE IS A LOT MORE TO THAT
                                HOWEVER.}{adh}
end;

function  PlugProcess(SlotH: LPSLOT):WORD;
var pState: WORD;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);
     pState := AlGetState(SlotH);

     Result := AL_IDLE;

     case pState of
          CA_IDLE: begin
                        Result := AL_IDLE;
                        AlUnlock(SlotH);
                        Exit;
                   end;
          CA_DONE: begin
                        Result := AL_DIE;
                        AlUnlock(SlotH);
                        Exit;
                   end;

     end;

     AlUnlock(SlotH);

end;

function  PlugDLLSize(SlotH: LPSLOT):LongInt;
var pFileSize: LongInt;
    pFile: file of BYTE;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);

     AssignFile(pFile,'GENCLINT.DLL');
     Reset(pFile);
     pFileSize := FileSize(pFile);
     CloseFile(pFile);

     AlUnlock(SlotH);

     Result := pFileSize;
end;

function  PlugNextDLL(SlotH: LPSLOT; name: PChar; limit: WORD; dest: PChar;
          dlim: WORD):BOOL;
var ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);

     if ds^.fFileSent = FALSE then
        begin
             StrPCopy( name, 'GENCLINT.DLL' );
             StrPCopy( dest, 'GENCLINT.DLL' );

             ds^.fFileSent := TRUE;
             AlUnlock(SlotH);
             Result := TRUE;
        end
        else
            begin
                 StrPCopy( name, '' );
                 StrPCopy( dest, '' );

                 AlUnlock(SlotH);
                 Result := FALSE;
            end;
end;

function  PlugDLLVerify(SlotH: LPSLOT; curOS: LongInt; info: Pointer;
          company, intern, ver, descript: PChar ):WORD;
var fSend: BOOL;
    pEMPTY: array[0..10] of Char;
    ds: ^CADataStruct;
begin
     ds := AlLock(SlotH);
     fSend := FALSE;
     StrPCopy(pEMPTY, '');

     if (StrComp(company, pEMPTY) = 0) or (StrComp(intern, pEMPTY) = 0)   or
        (StrComp(ver, pEMPTY) = 0)     or (StrComp(descript, pEMPTY) = 0) then
        fSend := TRUE;

     if fSend = TRUE then
        begin
             StrPCopy( company,  'HomeQuest BBS: 609-893-4031');
             StrPCopy( intern,   'Example Excalibur Plug');
             StrPCopy( ver,      '1.0');
             StrPCopy( descript, 'GenPlug');   {adh}

               {You'll need a resource editor that is capable of
               placing VERSIONINFO into your client DLL or when you
               complile it this information will not be present
               and it won't work}

             Result := NODLL_NONE;
        end
        else
            begin
                 Result := NODLL_OK;
            end;

     AlUnlock(SlotH);
end;

function  PlugCommand(SlotH: LPSLOT; cCMD: Pointer; cLen: WORD):WORD;
var lI: Integer;
    od: CommandData;
    td: ^CommandData;
    ds: ^CADataStruct;

begin
     ds := AlLock(SlotH);
     td := cCMD;
     case td^.cSTATE of
          CA_IDLE:   begin
                          {Note: The only really important
                          thing about the CommandData structure
                          is the cControlByte which tells the plugs
                          which plug entry point to go to.... the
                          extra 3 Bytes in AlAddBlock are for the
                          CommandData Struct it will have to increase
                          or decrease depending on what structures you
                          are sending accross the phone line}   {adh}
                          od.cControlByte := 1;
                          od.cSTATE := EX_START;
                          AlAddBlock(SlotH,@od,3);
                          AlSetState(SlotH,CA_IDLE); {To PlugProcess}
                     end;                                       {adh}
          CA_DONE:   begin
                          od.cControlByte := 1;
                          od.cSTATE := EX_DONE;
                          AlAddBlock(SlotH,@od,3);
                          AlSetState(SlotH,CA_DONE); {To PlugProcess}
                     end;                                        {adh}

          CA_INFO:   begin
                       od.cControlByte := 1;  {Assemble Data to be sent}{adh}
                       od.cSTATE := EX_INFO;
                       GetData(SlotH, od.cData);
                       AlAddBlock(SlotH, @od, 255); {To Client} {adh}
                       AlSetState(SlotH, CA_IDLE); {To PlugProcess} {adh}
                     end;

     end;

     AlUnlock(SlotH);
     Result := AL_OK;
end;

procedure GetData(var TheSlot: LPVOID; var TheData: TPlugInfo); {adh}
var TempBuf: Array[0..20] of Char;
    Return: String;

const
    crlf = #13#10;

begin
    AlGetUserFirst(TheSlot, TempBuf, 21);
     Return := StrPas(TempBuf);
    AlGetUserLast(TheSlot, TempBuf, 21);
     Return := Return + ' ' + StrPas(TempBuf);

 TheData.BBSName := 'Hello, ' + Return + ' !';
 TheData.Caption := 'HC_CONNECTION';
 TheData.Whatever:= crlf + 'I hope I''ve make this plug fairly ' +
                    'easy to understand. ' + ' I stripped out a lot of ' +
                    'things to make it more readable.' + crlf + 'Enjoy!' +
                    crlf + crlf + 'Argon D. Helm';
end;



end.
