unit Genmain;

interface

uses WinTypes, Classes, WinProcs,
     Graphics, Forms, Buttons,
     StdCtrls, SysUtils,
     Caexcomm, Exlib, Controls, ExtCtrls, Dialogs;

type
  THomeFrm = class(TForm)
    OKBtn: TBitBtn;
    DlgMain: TBevel;
    PicBox: TImage;
    PicFrameBvl: TBevel;
    TradMrkLbl: TLabel;
    Bevel1: TBevel;
    lblStatus: TLabel;
    DataViewer: TMemo;
    InfoBut: TSpeedButton;
    procedure OKBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure InfoButClick(Sender: TObject);
  private
    procedure RequestData(Act: Word);
    procedure ProcessData(Data: TPlugInfo);
  public
    {Some of these aren't really req'd} {adh}
    pSTATE:   WORD;
    pOD:      CommandData;
    pWnd, pChild, pWndChild: HWND;
    pLIBH: EXLIBH;
    pMAXIMIZED, pDOWNLOADED: BOOL;
  end;

var
  HomeFrm: THomeFrm;

function  PlugInit(LibH: EXLIBH; iARGS: PChar): Word; Export;
procedure PlugDestroy(LibH: EXLIBH); export;
function  PlugCommand(LibH: EXLIBH; cCMD: Pointer; cLEN: Word): Word; export;
function  PlugProcess(LibH: EXLIBH): Word; export;

implementation

{$R *.DFM}

function PlugInit(LibH: EXLIBH; iARGS: PChar): Word;
begin
   if not assigned(HomeFrm) then
      begin
       Application.Handle := ExMdiClient(LibH);
       Application.CreateForm(THomeFrm, HomeFrm);
       HomeFrm.Show;
      end;

      ExSetPtr(LibH, HomeFrm);
       HomeFrm.pLIBH := LibH;
       HomeFrm.pDOWNLOADED := TRUE;
       HomeFrm.pWND := ExMDIClient( LibH );
       HomeFrm.pSTATE := EX_INIT;

   Result := AL_OK;

end;

procedure PlugDestroy(LibH: EXLIBH);
begin

end;

function PlugCommand(LibH: EXLIBH; cCMD: Pointer; cLEN: WORD): WORD;
var
   lI: Integer;
   HomeFrm: THomeFrm;
   lOD: ^CommandData;

begin
   HomeFrm := ExGetPtr( LibH );
   lOD := cCMD;

      case lOD^.cSTATE of
         EX_START:  begin
                         HomeFrm.LblStatus.Caption := 'Server Active...';
                         HomeFrm.pState := EX_START;
                         Result := AL_OK;
                    end;

         EX_DONE:   begin
                         HomeFrm.LblStatus.Caption := 'Sent Close Command to Server...';
                         Result := AL_DIE;
                    end;

         EX_INFO: begin
                     HomeFrm.Caption := 'Got it!';
                     HomeFrm.ProcessData(lOD^.cData);
                     HomeFrm.pOD.cSTATE := CA_IDLE;
                     ExAddBlock(LibH, @HomeFrm.pOD, 3);
                     HomeFrm.pSTATE := EX_IDLE;
                     Result := AL_IDLE;
                   end;

         else
             Result := AL_OK;
    end;
end;

function PlugProcess(LibH: EXLIBH): WORD;
var
   HomeFrm: THomeFrm;
begin
   HomeFrm := ExGetPtr( LibH );
   HomeFrm.pOD.cControlByte := 1;

   PlugProcess := AL_OK;

   case HomeFrm.pSTATE of
      EX_INIT:   begin
                      HomeFrm.LblStatus.Caption := 'Server Initialized...';
                      HomeFrm.pOD.cSTATE := CA_IDLE;
                      ExAddBlock(LibH, @HomeFrm.pOD, 3);
                      HomeFrm.pSTATE := EX_IDLE;
                      Result := AL_IDLE;
                end;
      EX_START: begin
                      HomeFrm.LblStatus.Caption  := 'Initialize Client...';
                      HomeFrm.pSTATE := EX_IDLE;
                      Result := AL_OK;
                end;
      EX_IDLE:  begin
                     HomeFrm.LblStatus.Caption := 'Server at idle...';
                     PlugProcess := AL_IDLE;
                end;
      EX_CLOSE: begin
                     HomeFrm.LblStatus.Caption := 'Killing Plug...';
                     HomeFrm.pOD.cSTATE := CA_DONE;
                     ExAddBlock(LibH, @HomeFrm.pOD, 3);
                     HomeFrm.pSTATE := EX_IDLE;
                     Result := AL_IDLE;
                end;
   end;
end;


procedure THomeFrm.OKBtnClick(Sender: TObject);
begin
 pSTATE := EX_CLOSE;
end;

procedure THomeFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
pSTATE := EX_CLOSE;
Action := CaNone;
end;

procedure THomeFrm.RequestData(Act: Word);
begin
     pOD.cControlByte := 1;
     pOD.cSTATE := Act;
     ExAddBlock(pLIBH, @HomeFrm.pOD, 3); {Host = AlAddBlock
                                          Client = ExAddBlock} {adh}
end;

procedure THomeFrm.ProcessData(Data: TPlugInfo); {adh}
begin
 DataViewer.Clear;
 DataViewer.Text := Data.BBSName + #13#10 + #13#10 + Data.Whatever;
 Caption := Data.Caption;
end;

procedure THomeFrm.InfoButClick(Sender: TObject);
begin
 RequestData(CA_INFO);
end;

end.
